var bdshader = { frag: [
//"#extension GL_OES_standard_derivatives : enable",
"#define PHONG",
"uniform sampler2D dyeingMask;",
"uniform vec3 dyeColorR;",
"uniform float dyeSpecR;",
"uniform vec3 dyeColorG;",
"uniform float dyeSpecG;",
"uniform vec3 dyeColorB;",
"uniform float dyeSpecB;",
"",
"uniform vec3 diffuse;",
"uniform vec3 emissive;",
"uniform vec3 specular;",
"uniform float shininess;",
"uniform float opacity;",
"#define PI 3.14159",
"#define PI2 6.28318",
"#define RECIPROCAL_PI2 0.15915494",
"#define LOG2 1.442695",
"#define EPSILON 1e-6",
"",
"#define saturate(a) clamp( a, 0.0, 1.0 )",
"#define whiteCompliment(a) ( 1.0 - saturate( a ) )",
"",
"vec3 ColorDodge(vec3 src, vec3 dst) {",
"    return vec3((src.x == 1.0) ? 1.0 : min(1.0, dst.x / (1.0 - src.x)),",
"			(src.y == 1.0) ? 1.0 : min(1.0, dst.y / (1.0 - src.y)),",
"			(src.z == 1.0) ? 1.0 : min(1.0, dst.z / (1.0 - src.z)));",
"}",
"",
"vec3 transformDirection( in vec3 normal, in mat4 matrix ) {",
"	return normalize( ( matrix * vec4( normal, 0.0 ) ).xyz );",
"}",
"",
"vec3 inverseTransformDirection( in vec3 normal, in mat4 matrix ) {",
"	return normalize( ( vec4( normal, 0.0 ) * matrix ).xyz );",
"}",
"",
"vec3 projectOnPlane(in vec3 point, in vec3 pointOnPlane, in vec3 planeNormal ) {",
"	float distance = dot( planeNormal, point - pointOnPlane );",
"	return - distance * planeNormal + point;",
"}",
"",
"float sideOfPlane( in vec3 point, in vec3 pointOnPlane, in vec3 planeNormal ) {",
"	return sign( dot( point - pointOnPlane, planeNormal ) );",
"}",
"",
"vec3 linePlaneIntersect( in vec3 pointOnLine, in vec3 lineDirection, in vec3 pointOnPlane, in vec3 planeNormal ) {",
"	return lineDirection * ( dot( planeNormal, pointOnPlane - pointOnLine ) / dot( planeNormal, lineDirection ) ) + pointOnLine;",
"}",
"",
"float calcLightAttenuation( float lightDistance, float cutoffDistance, float decayExponent ) {",
"	if ( decayExponent > 0.0 ) {",
"	  return pow( saturate( -lightDistance / cutoffDistance + 1.0 ), decayExponent );",
"	}",
"	return 1.0;",
"}",
"",
"vec3 F_Schlick( in vec3 specularColor, in float dotLH ) {",
"	float fresnel = exp2( ( -5.55437 * dotLH - 6.98316 ) * dotLH );",
"	return ( 1.0 - specularColor ) * fresnel + specularColor;",
"}",
"",
"float G_BlinnPhong_Implicit( /* in float dotNL, in float dotNV */ ) {",
"	return 0.25;",
"}",
"",
"float D_BlinnPhong( in float shininess, in float dotNH ) {",
"	return ( shininess * 0.5 + 1.0 ) * pow( dotNH, shininess );",
"}",
"",
"vec3 BRDF_BlinnPhong( in vec3 specularColor, in float shininess, in vec3 normal, in vec3 lightDir, in vec3 viewDir ) {",
"	vec3 halfDir = normalize( lightDir + viewDir );",
"	float dotNH = saturate( dot( normal, halfDir ) );",
"	float dotLH = saturate( dot( lightDir, halfDir ) );",
"	vec3 F = F_Schlick( specularColor, dotLH );",
"	float G = G_BlinnPhong_Implicit( /* dotNL, dotNV */ );",
"	float D = D_BlinnPhong( shininess, dotNH );",
"	return F * G * D;",
"}",
"",
"vec3 inputToLinear( in vec3 a ) {",
"	#ifdef GAMMA_INPUT",
"		return pow( a, vec3( float( GAMMA_FACTOR ) ) );",
"	#else",
"		return a;",
"	#endif",
"}",
"",
"vec3 linearToOutput( in vec3 a ) {",
"	#ifdef GAMMA_OUTPUT",
"		return pow( a, vec3( 1.0 / float( GAMMA_FACTOR ) ) );",
"	#else",
"		return a;",
"	#endif",
"}",
"",
"#ifdef USE_COLOR",
"	varying vec3 vColor;",
"#endif",
"",
"#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP ) || defined( USE_ALPHAMAP ) || defined( USE_EMISSIVEMAP )",
"	varying vec2 vUv;",
"#endif",
"#if defined( USE_LIGHTMAP ) || defined( USE_AOMAP )",
"	varying vec2 vUv2;",
"#endif",
"#ifdef USE_MAP",
"	uniform sampler2D map;",
"#endif",
"#ifdef USE_ALPHAMAP",
"	uniform sampler2D alphaMap;",
"#endif",
"",
"#ifdef USE_AOMAP",
"	uniform sampler2D aoMap;",
"	uniform float aoMapIntensity;",
"#endif",
"#ifdef USE_LIGHTMAP",
"	uniform sampler2D lightMap;",
"	uniform float lightMapIntensity;",
"#endif",
"#ifdef USE_EMISSIVEMAP",
"	uniform sampler2D emissiveMap;",
"#endif",
"",
"#ifdef USE_ENVMAP",
"	uniform float reflectivity;",
"	#ifdef ENVMAP_TYPE_CUBE",
"		uniform samplerCube envMap;",
"	#else",
"		uniform sampler2D envMap;",
"	#endif",
"	uniform float flipEnvMap;",
"",
"	#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG )",
"		uniform float refractionRatio;",
"	#else",
"		varying vec3 vReflect;",
"	#endif",
"",
"#endif",
"",
"#ifdef USE_FOG",
"	uniform vec3 fogColor;",
"	#ifdef FOG_EXP2",
"		uniform float fogDensity;",
"	#else",
"		uniform float fogNear;",
"		uniform float fogFar;",
"	#endif",
"#endif",
"uniform vec3 ambientLightColor;",
"",
"#if MAX_DIR_LIGHTS > 0",
"	uniform vec3 directionalLightColor[ MAX_DIR_LIGHTS ];",
"	uniform vec3 directionalLightDirection[ MAX_DIR_LIGHTS ];",
"#endif",
"",
"#if MAX_HEMI_LIGHTS > 0",
"	uniform vec3 hemisphereLightSkyColor[ MAX_HEMI_LIGHTS ];",
"	uniform vec3 hemisphereLightGroundColor[ MAX_HEMI_LIGHTS ];",
"	uniform vec3 hemisphereLightDirection[ MAX_HEMI_LIGHTS ];",
"#endif",
"",
"#if MAX_POINT_LIGHTS > 0",
"	uniform vec3 pointLightColor[ MAX_POINT_LIGHTS ];",
"",
"	uniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];",
"	uniform float pointLightDistance[ MAX_POINT_LIGHTS ];",
"	uniform float pointLightDecay[ MAX_POINT_LIGHTS ];",
"#endif",
"",
"#if MAX_SPOT_LIGHTS > 0",
"	uniform vec3 spotLightColor[ MAX_SPOT_LIGHTS ];",
"	uniform vec3 spotLightPosition[ MAX_SPOT_LIGHTS ];",
"	uniform vec3 spotLightDirection[ MAX_SPOT_LIGHTS ];",
"	uniform float spotLightAngleCos[ MAX_SPOT_LIGHTS ];",
"	uniform float spotLightExponent[ MAX_SPOT_LIGHTS ];",
"	uniform float spotLightDistance[ MAX_SPOT_LIGHTS ];",
"	uniform float spotLightDecay[ MAX_SPOT_LIGHTS ];",
"#endif",
"",
"#if MAX_SPOT_LIGHTS > 0 || defined( USE_ENVMAP )",
"	varying vec3 vWorldPosition;",
"#endif",
"",
"varying vec3 vViewPosition;",
"",
"#ifndef FLAT_SHADED",
"	varying vec3 vNormal;",
"#endif",
"",
"#ifdef USE_BUMPMAP",
"	uniform sampler2D bumpMap;",
"	uniform float bumpScale;",
"",
"	vec2 dHdxy_fwd() {",
"		vec2 dSTdx = dFdx( vUv );",
"		vec2 dSTdy = dFdy( vUv );",
"		float Hll = bumpScale * texture2D( bumpMap, vUv ).x;",
"		float dBx = bumpScale * texture2D( bumpMap, vUv + dSTdx ).x - Hll;",
"		float dBy = bumpScale * texture2D( bumpMap, vUv + dSTdy ).x - Hll;",
"		return vec2( dBx, dBy );",
"	}",
"",
"	vec3 perturbNormalArb( vec3 surf_pos, vec3 surf_norm, vec2 dHdxy ) {",
"		vec3 vSigmaX = dFdx( surf_pos );",
"		vec3 vSigmaY = dFdy( surf_pos );",
"		vec3 vN = surf_norm;",
"		vec3 R1 = cross( vSigmaY, vN );",
"		vec3 R2 = cross( vN, vSigmaX );",
"		float fDet = dot( vSigmaX, R1 );",
"		vec3 vGrad = sign( fDet ) * ( dHdxy.x * R1 + dHdxy.y * R2 );",
"		return normalize( abs( fDet ) * surf_norm - vGrad );",
"	}",
"",
"#endif",
"",
"#ifdef USE_NORMALMAP",
"",
"	uniform sampler2D normalMap;",
"	uniform vec2 normalScale;",
"",
"",
"	vec3 perturbNormal2Arb( vec3 eye_pos, vec3 surf_norm ) {",
"",
"		vec3 q0 = dFdx( eye_pos.xyz );",
"		vec3 q1 = dFdy( eye_pos.xyz );",
"		vec2 st0 = dFdx( vUv.st );",
"		vec2 st1 = dFdy( vUv.st );",
"",
"		vec3 S = normalize( q0 * st1.t - q1 * st0.t );",
"		vec3 T = normalize( -q0 * st1.s + q1 * st0.s );",
"		vec3 N = normalize( surf_norm );",
"",
"		vec3 mapN = texture2D( normalMap, vUv ).xyz * 2.0 - 1.0;",
"		mapN.xy = normalScale * mapN.xy;",
"		mat3 tsn = mat3( S, T, N );",
"		return normalize( tsn * mapN );",
"	}",
"#endif",
"",
"#ifdef USE_SPECULARMAP",
"	uniform sampler2D specularMap;",
"#endif",
"",
"uniform float dyeable;",
"float newShininess;",
"",
"void main() {",
"   newShininess = 20.0;",
"   vec4 tDyeingMask = texture2D(dyeingMask, vUv);",
"   ",
"	vec3 outgoingLight = vec3( 0.0 );",
"	vec4 diffuseColor = vec4( diffuse, opacity );",
"	vec3 totalAmbientLight = ambientLightColor;",
"	vec3 totalEmissiveLight = emissive;",
"	vec3 shadowMask = vec3( 1.0 );",
"#ifdef USE_MAP",
"	vec4 texelColor = texture2D( map, vUv );",
"	texelColor.xyz = inputToLinear( texelColor.xyz );",
"	diffuseColor *= texelColor;",
"#endif",
"    ",
"    if (dyeable == 1.0) {",
"        if (tDyeingMask.r > 0.2  && diffuseColor.a > 0.0) {",
"            diffuseColor = vec4(ColorDodge(vec3(diffuseColor), dyeColorR), opacity);",
"            newShininess = dyeSpecR;",
"        }",
"        if (tDyeingMask.g > 0.2 && diffuseColor.a > 0.0) {",
"            diffuseColor = vec4(ColorDodge(vec3(diffuseColor), dyeColorG), opacity);",
"            newShininess = dyeSpecG;",
"        }",
"        if (tDyeingMask.b > 0.2 && diffuseColor.a > 0.0) {",
"            diffuseColor = vec4(ColorDodge(vec3(diffuseColor), dyeColorB), opacity);",
"            newShininess = dyeSpecB;",
"        }",
"    }",
"",
"#ifdef USE_COLOR",
"	diffuseColor.rgb *= vColor;",
"#endif",
"#ifdef USE_ALPHAMAP",
"	diffuseColor.a *= texture2D( alphaMap, vUv ).g;",
"#endif",
"",
"#ifdef ALPHATEST",
"	if ( diffuseColor.a < ALPHATEST ) discard;",
"#endif",
"",
"float specularStrength;",
"",
"#ifdef USE_SPECULARMAP",
"	vec4 texelSpecular = texture2D( specularMap, vUv );",
"	specularStrength = texelSpecular.g;",
"#else",
"	specularStrength = 1.0;",
"#endif",
"#ifndef FLAT_SHADED",
"	vec3 normal = normalize( vNormal );",
"	#ifdef DOUBLE_SIDED",
"		normal = normal * ( -1.0 + 2.0 * float( gl_FrontFacing ) );",
"	#endif",
"#else",
"	vec3 fdx = dFdx( vViewPosition );",
"	vec3 fdy = dFdy( vViewPosition );",
"	vec3 normal = normalize( cross( fdx, fdy ) );",
"#endif",
"",
"#ifdef USE_NORMALMAP",
"	normal = perturbNormal2Arb( -vViewPosition, normal );",
"#elif defined( USE_BUMPMAP )",
"	normal = perturbNormalArb( -vViewPosition, normal, dHdxy_fwd() );",
"#endif",
"",
"#ifdef USE_LIGHTMAP",
"	totalAmbientLight += texture2D( lightMap, vUv2 ).xyz * lightMapIntensity;",
"#endif",
"",
"#if MAX_HEMI_LIGHTS > 0",
"	for ( int i = 0; i < MAX_HEMI_LIGHTS; i ++ ) {",
"		vec3 lightDir = hemisphereLightDirection[ i ];",
"		float dotProduct = dot( normal, lightDir );",
"		float hemiDiffuseWeight = 0.5 * dotProduct + 0.5;",
"		vec3 lightColor = mix( hemisphereLightGroundColor[ i ], hemisphereLightSkyColor[ i ], hemiDiffuseWeight );",
"		totalAmbientLight += lightColor;",
"	}",
"#endif",
"",
"",
"#ifdef USE_AOMAP",
"	totalAmbientLight *= ( texture2D( aoMap, vUv2 ).r - 1.0 ) * aoMapIntensity + 1.0;",
"#endif",
"",
"#ifdef USE_EMISSIVEMAP",
"	vec4 emissiveColor = texture2D( emissiveMap, vUv );",
"	emissiveColor.rgb = inputToLinear( emissiveColor.rgb );",
"	totalEmissiveLight *= emissiveColor.rgb;",
"#endif",
"",
"vec3 viewDir = normalize( vViewPosition );",
"",
"vec3 totalDiffuseLight = vec3( 0.0 );",
"vec3 totalSpecularLight = vec3( 0.0 );",
"",
"#if MAX_POINT_LIGHTS > 0",
"	for ( int i = 0; i < MAX_POINT_LIGHTS; i ++ ) {",
"		vec3 lightColor = pointLightColor[ i ];",
"		vec3 lightPosition = pointLightPosition[ i ];",
"		vec3 lVector = lightPosition + vViewPosition.xyz;",
"		vec3 lightDir = normalize( lVector );",
"		float attenuation = calcLightAttenuation( length( lVector ), pointLightDistance[ i ], pointLightDecay[ i ] );",
"		float cosineTerm = saturate( dot( normal, lightDir ) );",
"		totalDiffuseLight += lightColor * attenuation * cosineTerm;",
"		vec3 brdf = BRDF_BlinnPhong( specular, newShininess, normal, lightDir, viewDir );",
"		totalSpecularLight += brdf * specularStrength * lightColor * attenuation * cosineTerm;",
"	}",
"#endif",
"",
"#if MAX_SPOT_LIGHTS > 0",
"	for ( int i = 0; i < MAX_SPOT_LIGHTS; i ++ ) {",
"		vec3 lightColor = spotLightColor[ i ];",
"		vec3 lightPosition = spotLightPosition[ i ];",
"		vec3 lVector = lightPosition + vViewPosition.xyz;",
"		vec3 lightDir = normalize( lVector );",
"		float spotEffect = dot( spotLightDirection[ i ], lightDir );",
"		if ( spotEffect > spotLightAngleCos[ i ] ) {",
"			spotEffect = saturate( pow( saturate( spotEffect ), spotLightExponent[ i ] ) );",
"			float attenuation = calcLightAttenuation( length( lVector ), spotLightDistance[ i ], spotLightDecay[ i ] );",
"			attenuation *= spotEffect;",
"			float cosineTerm = saturate( dot( normal, lightDir ) );",
"			totalDiffuseLight += lightColor * attenuation * cosineTerm;",
"			vec3 brdf = BRDF_BlinnPhong( specular, newShininess, normal, lightDir, viewDir );",
"			totalSpecularLight += brdf * specularStrength * lightColor * attenuation * cosineTerm;",
"		}",
"	}",
"",
"#endif",
"",
"#if MAX_DIR_LIGHTS > 0",
"	for ( int i = 0; i < MAX_DIR_LIGHTS; i ++ ) {",
"		vec3 lightColor = directionalLightColor[ i ];",
"		vec3 lightDir = directionalLightDirection[ i ];",
"		float cosineTerm = saturate( dot( normal, lightDir ) );",
"		totalDiffuseLight += lightColor * cosineTerm;",
"		vec3 brdf = BRDF_BlinnPhong( specular, newShininess, normal, lightDir, viewDir );",
"		totalSpecularLight += brdf * specularStrength * lightColor * cosineTerm;",
"	}",
"#endif",
"",
"totalDiffuseLight *= shadowMask;",
"totalSpecularLight *= shadowMask;",
"#ifdef METAL",
"	outgoingLight += diffuseColor.rgb * ( totalDiffuseLight + totalAmbientLight ) * specular + totalSpecularLight + totalEmissiveLight;",
"#else",
"	outgoingLight += diffuseColor.rgb * ( totalDiffuseLight + totalAmbientLight ) + totalSpecularLight + totalEmissiveLight;",
"#endif",
"#ifdef USE_ENVMAP",
"	#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG )",
"		vec3 cameraToVertex = normalize( vWorldPosition - cameraPosition );",
"		vec3 worldNormal = inverseTransformDirection( normal, viewMatrix );",
"		#ifdef ENVMAP_MODE_REFLECTION",
"			vec3 reflectVec = reflect( cameraToVertex, worldNormal );",
"		#else",
"			vec3 reflectVec = refract( cameraToVertex, worldNormal, refractionRatio );",
"		#endif",
"	#else",
"		vec3 reflectVec = vReflect;",
"	#endif",
"",
"	#ifdef DOUBLE_SIDED",
"		float flipNormal = ( float( gl_FrontFacing ) * 2.0 - 1.0 );",
"	#else",
"		float flipNormal = 1.0;",
"	#endif",
"",
"	#ifdef ENVMAP_TYPE_CUBE",
"		vec4 envColor = textureCube( envMap, flipNormal * vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );",
"	#elif defined( ENVMAP_TYPE_EQUIREC )",
"		vec2 sampleUV;",
"		sampleUV.y = saturate( flipNormal * reflectVec.y * 0.5 + 0.5 );",
"		sampleUV.x = atan( flipNormal * reflectVec.z, flipNormal * reflectVec.x ) * RECIPROCAL_PI2 + 0.5;",
"		vec4 envColor = texture2D( envMap, sampleUV );",
"	#elif defined( ENVMAP_TYPE_SPHERE )",
"		vec3 reflectView = flipNormal * normalize((viewMatrix * vec4( reflectVec, 0.0 )).xyz + vec3(0.0,0.0,1.0));",
"		vec4 envColor = texture2D( envMap, reflectView.xy * 0.5 + 0.5 );",
"	#endif",
"",
"	envColor.xyz = inputToLinear( envColor.xyz );",
"",
"	#ifdef ENVMAP_BLENDING_MULTIPLY",
"		outgoingLight = mix( outgoingLight, outgoingLight * envColor.xyz, specularStrength * reflectivity );",
"	#elif defined( ENVMAP_BLENDING_MIX )",
"		outgoingLight = mix( outgoingLight, envColor.xyz, specularStrength * reflectivity );",
"	#elif defined( ENVMAP_BLENDING_ADD )",
"		outgoingLight += envColor.xyz * specularStrength * reflectivity;",
"	#endif",
"#endif",
"",
"",
"	outgoingLight = linearToOutput( outgoingLight );",
"",
"#ifdef USE_FOG",
"	#ifdef USE_LOGDEPTHBUF_EXT",
"		float depth = gl_FragDepthEXT / gl_FragCoord.w;",
"	#else",
"		float depth = gl_FragCoord.z / gl_FragCoord.w;",
"	#endif",
"	#ifdef FOG_EXP2",
"		float fogFactor = whiteCompliment( exp2( - fogDensity * fogDensity * depth * depth * LOG2 ) );",
"	#else",
"		float fogFactor = smoothstep( fogNear, fogFar, depth );",
"	#endif",
"	",
"	outgoingLight = mix( outgoingLight, fogColor, fogFactor );",
"#endif",
"	gl_FragColor = vec4( outgoingLight, diffuseColor.a );",
"}",
].join("\r"), vert : [
"#define PHONG",
"varying vec3 vViewPosition;",
"#ifndef FLAT_SHADED",
"	varying vec3 vNormal;",
"#endif",
"#define PI 3.14159",
"#define PI2 6.28318",
"#define RECIPROCAL_PI2 0.15915494",
"#define LOG2 1.442695",
"#define EPSILON 1e-6",
"",
"#define saturate(a) clamp( a, 0.0, 1.0 )",
"#define whiteCompliment(a) ( 1.0 - saturate( a ) )",
"",
"vec3 transformDirection( in vec3 normal, in mat4 matrix ) {",
"	return normalize( ( matrix * vec4( normal, 0.0 ) ).xyz );",
"}",
"",
"vec3 inverseTransformDirection( in vec3 normal, in mat4 matrix ) {",
"	return normalize( ( vec4( normal, 0.0 ) * matrix ).xyz );",
"}",
"",
"vec3 projectOnPlane(in vec3 point, in vec3 pointOnPlane, in vec3 planeNormal ) {",
"	float distance = dot( planeNormal, point - pointOnPlane );",
"	return - distance * planeNormal + point;",
"}",
"",
"float sideOfPlane( in vec3 point, in vec3 pointOnPlane, in vec3 planeNormal ) {",
"	return sign( dot( point - pointOnPlane, planeNormal ) );",
"}",
"",
"vec3 linePlaneIntersect( in vec3 pointOnLine, in vec3 lineDirection, in vec3 pointOnPlane, in vec3 planeNormal ) {",
"	return lineDirection * ( dot( planeNormal, pointOnPlane - pointOnLine ) / dot( planeNormal, lineDirection ) ) + pointOnLine;",
"}",
"",
"float calcLightAttenuation( float lightDistance, float cutoffDistance, float decayExponent ) {",
"	if ( decayExponent > 0.0 ) {",
"	  return pow( saturate( -lightDistance / cutoffDistance + 1.0 ), decayExponent );",
"	}",
"	return 1.0;",
"}",
"",
"vec3 F_Schlick( in vec3 specularColor, in float dotLH ) {",
"	float fresnel = exp2( ( -5.55437 * dotLH - 6.98316 ) * dotLH );",
"	return ( 1.0 - specularColor ) * fresnel + specularColor;",
"}",
"",
"float G_BlinnPhong_Implicit( /* in float dotNL, in float dotNV */ ) {",
"	return 0.25;",
"}",
"",
"float D_BlinnPhong( in float shininess, in float dotNH ) {",
"	return ( shininess * 0.5 + 1.0 ) * pow( dotNH, shininess );",
"}",
"",
"vec3 BRDF_BlinnPhong( in vec3 specularColor, in float shininess, in vec3 normal, in vec3 lightDir, in vec3 viewDir ) {",
"	vec3 halfDir = normalize( lightDir + viewDir );",
"	float dotNH = saturate( dot( normal, halfDir ) );",
"	float dotLH = saturate( dot( lightDir, halfDir ) );",
"	vec3 F = F_Schlick( specularColor, dotLH );",
"	float G = G_BlinnPhong_Implicit( /* dotNL, dotNV */ );",
"	float D = D_BlinnPhong( shininess, dotNH );",
"	return F * G * D;",
"}",
"",
"vec3 inputToLinear( in vec3 a ) {",
"	#ifdef GAMMA_INPUT",
"		return pow( a, vec3( float( GAMMA_FACTOR ) ) );",
"	#else",
"		return a;",
"	#endif",
"}",
"",
"vec3 linearToOutput( in vec3 a ) {",
"	#ifdef GAMMA_OUTPUT",
"		return pow( a, vec3( 1.0 / float( GAMMA_FACTOR ) ) );",
"	#else",
"		return a;",
"	#endif",
"}",
"",
"#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP ) || defined( USE_ALPHAMAP ) || defined( USE_EMISSIVEMAP )",
"	varying vec2 vUv;",
"	uniform vec4 offsetRepeat;",
"#endif",
"",
"#if defined( USE_LIGHTMAP ) || defined( USE_AOMAP )",
"	attribute vec2 uv2;",
"	varying vec2 vUv2;",
"#endif",
"",
"#if defined( USE_ENVMAP ) && ! defined( USE_BUMPMAP ) && ! defined( USE_NORMALMAP ) && ! defined( PHONG )",
"	varying vec3 vReflect;",
"	uniform float refractionRatio;",
"#endif",
"",
"#if MAX_SPOT_LIGHTS > 0 || defined( USE_ENVMAP )",
"	varying vec3 vWorldPosition;",
"#endif",
"",
"#if MAX_POINT_LIGHTS > 0",
"	uniform vec3 pointLightPosition[ MAX_POINT_LIGHTS ];",
"#endif",
"",
"#ifdef USE_COLOR",
"	varying vec3 vColor;",
"#endif",
"",
"#ifdef USE_SHADOWMAP",
"	uniform float shadowDarkness[ MAX_SHADOWS ];",
"	uniform mat4 shadowMatrix[ MAX_SHADOWS ];",
"	varying vec4 vShadowCoord[ MAX_SHADOWS ];",
"#endif",
"",
"void main() {",
"#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP ) || defined( USE_ALPHAMAP ) || defined( USE_EMISSIVEMAP )",
"	vUv = uv * offsetRepeat.zw + offsetRepeat.xy;",
"#endif",
"#if defined( USE_LIGHTMAP ) || defined( USE_AOMAP )",
"	vUv2 = uv2;",
"#endif",
"#ifdef USE_COLOR",
"	vColor.xyz = color.xyz;",
"#endif",
"",
"vec3 objectNormal = vec3( normal );",
"",
"#ifdef FLIP_SIDED",
"	objectNormal = -objectNormal;",
"#endif",
"",
"vec3 transformedNormal = normalMatrix * objectNormal;",
"",
"#ifndef FLAT_SHADED",
"	vNormal = normalize( transformedNormal );",
"#endif",
"",
"vec3 transformed = vec3( position );",
"",
"vec4 mvPosition = modelViewMatrix * vec4( transformed, 1.0 );",
"",
"gl_Position = projectionMatrix * mvPosition;",
"",
"vViewPosition = - mvPosition.xyz;",
"",
"#if defined( USE_ENVMAP ) || defined( PHONG ) || defined( LAMBERT ) || defined ( USE_SHADOWMAP )",
"	vec4 worldPosition = modelMatrix * vec4( transformed, 1.0 );",
"#endif",
"",
"#if MAX_SPOT_LIGHTS > 0 || defined( USE_ENVMAP )",
"	vWorldPosition = worldPosition.xyz;",
"#endif",
"}"
].join("\r") };